; Studio Tecnico Arch. Giuseppe Conte  
; 72026 - San Pancrazio Salentino (BR) - Italy
;
; Plugin  : brush-to-array.scm
; Author  : Arch. Giuseppe Conte 
; Date    : 28 novembre 2004 - San Pancrazio Salentino
; Revision: 28 luglio 2008  Update to Tiny Scheme
; Version : 2.0
; Last version at: http://xoomer.alice.it/lwcon/gimp/
; Help guide at  : http://xoomer.alice.it/lwcon/gimp/scripts/brush-to-array.htm
;
; Dependencie: 
; Download   : http://xoomer.alice.it/lwcon/gimp/script-fu/script-fu.htm
;
; Description: 
; To draw an array n x m with active brush.
; 
; 
; -----------------------------------------------------------------------------
;
; License:
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
; 
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
; 
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
; -----------------------------------------------------------------------------
;
; Define the function:

(define (script-fu-brush-to-array inImage inLayer righe colonne dy dx px py)

	(let* (	(ycount 0)
  				(xcount 0)
  				(point (make-vector 2))
				)

  				(vector-set! point 0 px)
  				(vector-set! point 1 py)
  
  (while (<= ycount righe)
  		
  		(while (< xcount colonne)
			(begin
			(gimp-paintbrush inLayer 0 2 point 0 0)
			(vector-set! point 0 (+ px (* dx xcount)))
			(set! xcount (+ xcount 1))
			);end begin
			
   		(gimp-displays-flush)
   		
  		);end while colonne
  		
  		(set! xcount 0)
  		(vector-set! point 1 (+ py (* dy ycount)))
  		(set! ycount (+ ycount 1))

  );end while righe
 
	);let 
) ;;def



(script-fu-register
 "script-fu-brush-to-array"
 _"<Image>/_ATG/A_rray/Brush to array"
 "To draw an array n x m with active brush.
 Tutorial and help guide on web site:
 http://xoomer.alice.it/lwcon/gimp/  
 "
 "Arch. Giuseppe Conte"
 "Giuseppe Conte"
 "28 luglio 2008 - Ver. 2.0"
 "RGB* GRAY* INDEXED*"
 SF-IMAGE "The Image" 0
 SF-DRAWABLE "The Layer" 0
 SF-ADJUSTMENT "Righe" '(1 1 9999 1 10 0 1)
 SF-ADJUSTMENT "Colonne" '(1 1 9999 1 10 0 1)
 SF-ADJUSTMENT "Distanza tra le righe" '(0 -9999 9999 1 10 0 1)
 SF-ADJUSTMENT "Distanza tra le colonne" '(0 -9999 9999 1 10 0 1)
 SF-ADJUSTMENT "X Punto iniziale" '(0 -9999 9999 1 10 0 1)
 SF-ADJUSTMENT "Y Punto iniziale" '(0 -9999 9999 1 10 0 1) 
)
