; Canvas-Texture v2.5.0
; Copyright (c) 2006-2010 Frank Kessler <www.Kessnux.net>
;
; Tested with TheGIMP 2.6.7 under Mandriva Linux 2010 at 2010-03-20.
;
; This program based on the german Tutorial of Frank Kessler,
; the first version of the german Tutorial from 2004 based
; on techniques of Zach Beane (xach).
;
; This program is subjected to the Kessnux free usage license Version 1.0.
; If you have not received a copy of the KFNL, you could see it
; at <http://www.kessnux.net/kfnl_10_en.php>
;

(define (script-fu-canvas-texture breite hoehe staerke)

(let* ((bild (car (gimp-image-new breite hoehe 0)))
	(struktur-layer (car (gimp-layer-new bild breite hoehe 0 "Canvas" 100 0)))
	(ff-alt (car (gimp-palette-get-foreground)))
	(hf-alt (car (gimp-palette-get-foreground)))
	(neuerlayer 0)
	(einzel-layer 0))
	
	(gimp-image-undo-disable bild)
	
	(gimp-image-add-layer bild struktur-layer 1)
	
	;Layer vorbereiten
	(gimp-palette-set-foreground '(255 255 255))
	(gimp-edit-clear struktur-layer)
	(gimp-edit-fill struktur-layer 0)
	
	;Struktur erzeugen
	(plug-in-rgb-noise TRUE bild struktur-layer FALSE FALSE 0.90 0.90 0.90 0.90)
	(set! neuerlayer (car (gimp-layer-new-from-drawable struktur-layer bild)))
	(gimp-image-add-layer bild neuerlayer -1)
	(plug-in-gauss TRUE bild struktur-layer staerke 0 1)
	(plug-in-gauss TRUE bild neuerlayer 0 staerke 1)
	(gimp-layer-set-mode neuerlayer 3)
	(set! einzel-layer (car (gimp-image-merge-visible-layers bild 0)))
	(plug-in-c-astretch TRUE bild einzel-layer)
	(plug-in-rgb-noise TRUE bild einzel-layer FALSE FALSE 0.10 0.10 0.10 0.10)
	(gimp-levels einzel-layer 0 0 255 1.80 0 255)
	(gimp-levels einzel-layer 1 0 255 1.40 0 255)
	(gimp-levels einzel-layer 2 0 255 0.80 0 255)
	(gimp-levels einzel-layer 3 0 255 0.40 0 255)
	
	;nahtlos machen
	(plug-in-make-seamless 0 bild einzel-layer)
	
	;alten Zustand wiederherstellen
	(gimp-palette-set-foreground ff-alt)
	(gimp-palette-set-background hf-alt)
	
	(gimp-image-undo-enable bild)
	(gimp-display-new bild)))
	
(script-fu-register "script-fu-canvas-texture"
		    "<Image>/Filters/Render/Pattern/Canvas-Texture"
		    "generates a texture like canvas"
		    "Frank Kessler"
		    "Frank Kessler"
		    "2010"
		    ""
		    SF-ADJUSTMENT "Image width"   '(300 1 1024 1 10 0 1)
		    SF-ADJUSTMENT "Image height"  '(200 1 1024 1 10 0 1)
		    SF-ADJUSTMENT "Strength"      '(9 1 255 1 10 0 1))
		    