; Brushed-Metal-Texture v2.5.0
; Copyright (c) 2005-2010 Frank Kessler <www.Kessnux.net>
;
; Tested with TheGIMP 2.6.7 under Mandriva Linux 2010 at 2010-03-20.
;
; This program based on the german Tutorial of Frank Kessler,
; the first version of the german Tutorial from 2004 based
; on techniques of Gavin Brown (Jodrell).
;
; This program is subjected to the Kessnux free usage license Version 1.0.
; If you have not received a copy of the KFNL, you could see it
; at <http://www.kessnux.net/kfnl_10_en.php>
;

(define (script-fu-metal-texture breite hoehe zufallswert)

(let* ((bild (car (gimp-image-new breite hoehe 0)))
	(hg-layer (car (gimp-layer-new bild (+ (/ breite 2) 100) (+ (/ hoehe 2) 100) 0 "Hintergrund" 100 0)))
	(struktur-layer (car (gimp-layer-new bild (+ (/ breite 2) 100) (+ (/ hoehe 2) 100) 0 "Struktur" 100 0)))
	(vereinigter-layer (car (gimp-layer-new bild (+ (/ breite 2) 100) (+ (/ hoehe 2) 100) 0 "vereinigt" 100 0)))
	(nahtlos-layer (car (gimp-layer-new bild (/ breite 2) (/ hoehe 2) 0 "nahtlos" 100 0)))
	(verbundener-layer (car (gimp-layer-new bild (/ breite 2) (/ hoehe 2) 0 "verbunden" 100 0)))
	(ff-alt (car (gimp-palette-get-foreground)))
	(hf-alt (car (gimp-palette-get-foreground))))
	
	(gimp-image-undo-disable bild)
	
	(gimp-image-add-layer bild hg-layer 1)
	(gimp-image-add-layer bild struktur-layer -1)
	
	;Layer vorbereiten
	(gimp-palette-set-foreground '(255 255 255))
	(gimp-edit-clear hg-layer)
	(gimp-edit-fill hg-layer 0)
	(gimp-edit-clear struktur-layer)
	(gimp-edit-fill struktur-layer 0)
	
	;Hintergrund erzeugen
	(plug-in-solid-noise TRUE bild hg-layer 0 0 zufallswert 1 1.0 1.0)
	
	;Struktur erzeugen
	(plug-in-rgb-noise TRUE bild struktur-layer FALSE FALSE 0.40 0.40 0.40 0.40)
	(plug-in-mblur TRUE bild struktur-layer 0 10 0 10 10)
	(gimp-layer-set-opacity struktur-layer 30)
	(set! vereinigter-layer (car(gimp-image-merge-down bild struktur-layer 0)))
	(gimp-layer-resize vereinigter-layer (/ breite 2) (/ hoehe 2) -50 -50)
	(gimp-layer-set-offsets vereinigter-layer 0 0)
	
	;nahtlos machen
	(set! nahtlos-layer (car(gimp-layer-copy vereinigter-layer 1)))
	(gimp-image-add-layer bild nahtlos-layer -1)
	(gimp-flip nahtlos-layer 0)
	(gimp-layer-set-offsets nahtlos-layer (/ breite 2) 0)
	(set! verbundener-layer (car(gimp-image-merge-down bild nahtlos-layer 0)))
	(set! nahtlos-layer (car(gimp-layer-copy verbundener-layer 1)))
	(gimp-image-add-layer bild nahtlos-layer -1)
	(gimp-flip nahtlos-layer 1)
	(gimp-layer-set-offsets nahtlos-layer 0 (/ hoehe 2))
	(gimp-image-merge-down bild nahtlos-layer 0)
	
	;alten Zustand wiederherstellen
	(gimp-palette-set-foreground ff-alt)
	(gimp-palette-set-background hf-alt)
	
	(gimp-image-undo-enable bild)
	(gimp-display-new bild)))
	
(script-fu-register "script-fu-metal-texture"
		    "<Image>/Filters/Render/Pattern/Brushed-Metal-Texture"
		    "generates a texture like brushed metal"
		    "Frank Kessler"
		    "Frank Kessler"
		    "2010"
		    ""
		    SF-ADJUSTMENT "Image width"   '(300 1 1024 1 10 0 1)
		    SF-ADJUSTMENT "Image height"   '(200 1 1024 1 10 0 1)
		    SF-ADJUSTMENT "Random-Value" '(2784479764 1000000000 9999999999 1 10 1 0))
		    